Package org.apache.sysds.runtime.controlprogram.caching

## Class FrameObject

- java.lang.Object
- - org.apache.sysds.runtime.instructions.cp.Data
  - - org.apache.sysds.runtime.controlprogram.caching.CacheableData<FrameBlock>
    - - org.apache.sysds.runtime.controlprogram.caching.FrameObject

- All Implemented Interfaces:
    `Serializable`

      public class FrameObject
      extends CacheableData<FrameBlock>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.controlprogram.caching.CacheableData

      `CacheableData.CacheStatus`

  - ### Field Summary

    - ### Fields inherited from class org.apache.sysds.runtime.controlprogram.caching.CacheableData

      `cacheEvictionLocalFilePath, cacheEvictionLocalFilePrefix, CACHING_ASYNC_FILECLEANUP, CACHING_ASYNC_SERIALIZE, CACHING_BUFFER_PAGECACHE, CACHING_BUFFER_POLICY, CACHING_COUNTER_GROUP_NAME, CACHING_EVICTION_FILEEXTENSION, CACHING_THRESHOLD, CACHING_WRITE_CACHE_ON_READ`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FrameObject​(String fname)` |
    `FrameObject​(String fname, MetaData meta)` |
    `FrameObject​(String fname, MetaData meta, Types.ValueType[] schema)` |
    `FrameObject​(FrameObject fo)` | Copy constructor that copies meta data but NO data.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `long` | `getNumColumns()` |
    `long` | `getNumRows()` |
    `Types.ValueType[]` | `getSchema()` |
    `Types.ValueType[]` | `getSchema​(int cl, int cu)` | Obtain schema of value types
    `Types.ValueType[]` | `mergeSchemas​(FrameObject fo)` | Creates a new collection which contains the schema of the current frame object concatenated with the schema of the passed frame object.
    `void` | `refreshMetaData()` |
    `void` | `setSchema​(String schema)` |
    `void` | `setSchema​(Types.ValueType[] schema)` |

    - ### Methods inherited from class org.apache.sysds.runtime.controlprogram.caching.CacheableData

      `acquireModify, acquireRead, acquireReadAndRelease, addBroadcastSize, cleanupCacheDir, cleanupCacheDir, clearData, clearData, disableCaching, enableCaching, enableCleanup, exportData, exportData, exportData, exportData, exportData, freeEvictedBlob, getBlocksize, getBroadcastHandle, getBroadcastSize, getCacheLineage, getCompressedSize, getDataCharacteristics, getDataSize, getDebugName, getDim, getFedMapping, getFileFormatProperties, getFileName, getGPUObject, getMetaData, getRDDHandle, getStatus, getUniqueID, hasValidLineage, initCaching, initCaching, isBelowCachingThreshold, isCached, isCachingActive, isCleanupEnabled, isCompressed, isDirty, isFederated, isFederated, isFederatedExcept, isHDFSFileExists, isPendingRDDOps, moveData, release, removeGPUObject, removeMetaData, setBroadcastHandle, setCacheLineage, setCompressedSize, setDirty, setEmptyStatus, setFedMapping, setFileFormatProperties, setFileName, setGPUObject, setHDFSFileExists, setMetaData, setRDDHandle, toString`

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.cp.Data

      `getDataType, getPrivacyConstraint, getValueType, setPrivacyConstraints, updateDataCharacteristics`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FrameObject

          public FrameObject​(String fname)

    - #### FrameObject

          public FrameObject​(String fname,
                             MetaData meta)

    - #### FrameObject

          public FrameObject​(String fname,
                             MetaData meta,
                             Types.ValueType[] schema)

    - #### FrameObject

          public FrameObject​(FrameObject fo)

      Copy constructor that copies meta data but NO data.
      Parameters:
        `fo` - frame object

  - ### Method Detail

    - #### getSchema

          public Types.ValueType[] getSchema()

    - #### getSchema

          public Types.ValueType[] getSchema​(int cl,
                                             int cu)

      Obtain schema of value types
      Parameters:
        `cl` - column lower bound, inclusive
        `cu` - column upper bound, inclusive
      Returns:
        schema of value types

    - #### mergeSchemas

          public Types.ValueType[] mergeSchemas​(FrameObject fo)

      Creates a new collection which contains the schema of the current frame object concatenated with the schema of the passed frame object.
      Parameters:
        `fo` - frame object
      Returns:
        schema of value types

    - #### setSchema

          public void setSchema​(String schema)

    - #### setSchema

          public void setSchema​(Types.ValueType[] schema)

    - #### refreshMetaData

          public void refreshMetaData()

      Specified by:
        `refreshMetaData` in class `CacheableData<FrameBlock>`

    - #### getNumRows

          public long getNumRows()

      Overrides:
        `getNumRows` in class `CacheableData<FrameBlock>`

    - #### getNumColumns

          public long getNumColumns()

      Overrides:
        `getNumColumns` in class `CacheableData<FrameBlock>`